# __________________________________________________________ #
#                                |                           #
#  이토록 쉬운                   |     "데이터는 답이다"     #
#  데이터 요약과 시각화 with R   |       _                   #
# ______________________________ |    __| |   __ _   _ __    #
#                                |   / _` |  / _` | | '_ \   #
#  임경덕                        |  | (_| | | (_| | | |_) |  # 
#   - dataartproject@gmail.com   |   \__,_|  \__,_| | .__/   #
#   - http://dataartproject.com  |                  |_|      #
# _______________________________|__________________________ #



# 3장 | 데이터 불러와서 살펴보기

# 데이터 불러오기, 정보 확인 및 기초 전처리





# 3.1 CSV 파일 불러오기 ---------------------------------------------------------


# [코드 3-1]
sample = read.csv("data/sample1.csv")
sample



# [코드 3-2]
sample = read.csv("data\\sample1.csv")
  # Windows에서만 가능(macOS는 불가능)

sample = read.csv("data/sample1.csv")



# [코드 3-3]
my_practice = read.csv(file = "data/practice/weather.csv")




# [코드 3-4]
read.csv("data/practice/encoding_utf8.csv", fileEncoding = "UTF-8")
read.csv("data/practice/encoding_euckr.csv", fileEncoding = "euc-kr")





# 3.2 XLSX 파일 불러오기 --------------------------------------------------------


# [코드 3-5]
library(readxl)



# [코드 3-6]
data_sheet1 = read_excel("data/practice/a_excel_file.xlsx", sheet = 1)
data_sheet2 = read_excel("data/practice/a_excel_file.xlsx", sheet = 2, skip = 2)





# 3.3 데이터 살펴보기 ------------------------------------------------------------


# [코드 3-7]
my_practice
  # View(my_practice)




# [코드 3-8]
head(my_practice) 
tail(my_practice, n = 3)



# [코드 3-9]
names(my_practice)



# [코드 3-10]
x = c("A", "C")
x  



# [코드 3-11]
x = c("X", "Y")
x  



# [코드 3-12]
names(sample)
names(sample) = paste0("V", 1:4)
sample



# [코드 3-13]
my_practice
my_practice$temp_high



# [코드 3-14]
max(my_practice$temp_high)



# [코드 3-15]
dim(my_practice)



# [코드 3-16]
nrow(my_practice)
ncol(my_practice)



# [코드 3-17]
LETTERS
length(LETTERS)



# [코드 3-18]
my_practice = read.csv("data/practice/weather.csv")
head(my_practice)
names(my_practice)
dim(my_practice)





# 3.4 데이터 결합하기 ------------------------------------------------------------


# [코드 3-19]
library(readxl)
data_1 = read_excel("data/practice/apt/apt_강남구.xlsx")
data_2 = read_excel("data/practice/apt/apt_서초구.xlsx")
data_3 = read_excel("data/practice/apt/apt_송파구.xlsx")

dim(data_1)
dim(data_2)
dim(data_3)

head(data_1, n = 2)
head(data_2, n = 2)
head(data_3, n = 2)



# [코드 3-20]
data_123 = rbind(data_1, data_2, data_3)
dim(data_123)



# [코드 3-21]
d_left  = read.csv("data/practice/data_left.csv")
d_right = read.csv("data/practice/data_right.csv")
d_left
d_right



# [코드 3-22]
d_merged = merge(d_left, d_right, by.x = "category", by.y = "category")
d_merged


  # merge(d_left, d_right, by = "category")




# [코드 3-23]
merge(d_left, d_right, by = "category", all.x = T)



# [코드 3-24]
merge(d_left, d_right, by = "category", all.y = T)



# [코드 3-25]
merge(d_left, d_right, by = "category", all = T)




# [코드 3-26]
floating   = read.csv("data/practice/floating_population.csv", fileEncoding = "euc-kr")
population = read.csv("data/practice/population.csv", fileEncoding = "euc-kr")

head(floating, n = 3)
head(population, n = 3)



  # merge(floating, population, by=c("자치구", "연령대"))
  # merge(floating, population, by=c("자치구"))




# End of script