  # __________________________________________________________ #
  #                                |                           #
  #  이토록 쉬운                   |     "데이터는 답이다"     #
  #  데이터 요약과 시각화 with R   |       _                   #
  # ______________________________ |    __| |   __ _   _ __    #
  #                                |   / _` |  / _` | | '_ \   #
  #  임경덕                        |  | (_| | | (_| | | |_) |  # 
  #   - dataartproject@gmail.com   |   \__,_|  \__,_| | .__/   #
  #   - http://dataartproject.com  |                  |_|      #
  # _______________________________|__________________________ #



# 4장 | 패키지를 활용한 요약과 시각화

# tidyverse를 활용한 데이터의 요약과 시각화
  # tidyverse = dplyr + tidyr + ggplot2 + readxl + tibble + magrittr + ... 
  # 참고 : https://www.tidyverse.org/
  #        https://r4ds.had.co.nz/




# 4.1 실습 데이터 불러오기 ---------------------------------------------------------

  ## 꼭 확인해주세요! ##

  ## 한번에 모든 실습을 끝낼 수 없기 때문에, RStudio를 여러번 재시작하게 됩니다. 
  ## RStudio 종료 시 '객체 저장 여부'를 묻는데, 
  ## [Yes]를 클릭하면 RStudio가 재시작될 때 이전 작업 내용 및 객체/데이터를 복원합니다.
  
  ## 그렇지 않은 경우 원활한 실습을 위해서 RStudio가 실행될 때마다 
  ## 아래의 [코드 4-1]를 실행해서 예제 데이터를 꼭 불러와서 객체로 저장해야 합니다. 



  ## 이것도 확인해주세요! ##
  ## dplyr, ggplot2과 같은 라이브러리는 RStudio가 재시작될 때마다 다시 불러와야 합니다.
  ## 혹시나 '함수가 없습니다'와 같은 오류 문구가 등장하면
  ## library(dplyr), library(ggplot2) 등으로 라이브러리 불러오기를 실행하면 됩니다. 




# [코드 4-1] 

checkout = read.csv("data/checkout.csv", fileEncoding = "UTF-8")
customer = read.csv("data/customer.csv", fileEncoding = "UTF-8")
merchant = read.csv("data/merchant.csv", fileEncoding = "UTF-8")




# 4.2 magrittr 패키지의 %>% ---------------------------------------------------


# [코드 4-2] 
head(checkout)



# [코드 4-3]
library(magrittr)
checkout %>% head()



# [코드 4-4]
library(dplyr)
arrange(
  summarise(
    group_by(
      filter(checkout, category == "홈쇼핑"), cust_id), 결제금액 = sum(amount)), 결제금액)



# [코드 4-5]
A = filter(checkout, category == "홈쇼핑")
B = group_by(A, cust_id)
C = summarise(B, 결제금액 = sum(amount))
arrange(C, 결제금액)





# [코드 4-6]
checkout %>% 
  filter(category == "홈쇼핑") %>% 
  group_by(cust_id) %>% 
  summarise(결제금액 = sum(amount)) %>% 
  arrange(결제금액)



# [코드 4-7]
checkout %>% 
  # filter(category == "홈쇼핑") %>% 
  group_by(cust_id) %>% 
  summarise(결제금액 = sum(amount)) %>% 
  arrange(결제금액)



# [코드 4-8]
checkout %>% 
  filter(category == "홈쇼핑") %>% 
  # group_by(cust_id) %>% 
  summarise(결제금액 = sum(amount)) %>% 
  arrange(결제금액)





# 4.3 tibble 패키지의 tibble( ) 함수 --------------------------------------------

# [코드 4-9]
checkout %>% head()




# [코드 4-10]
tibble(checkout)






# 4.4 dplyr 패키지의 함수 -------------------------------------------------------

# [코드 4-11]
checkout %>%
  summarise(sum(amount))



# [코드 4-12]
checkout %>% sum(amount)



# [코드 4-13]
checkout %>%
  summarise(total = sum(amount))




# [코드 4-14]
checkout %>%
  summarise(SUM    = sum(amount),
            MEAN   = mean(amount),
            n1     = length(amount),
            n2     = n(),
            n_cust = n_distinct(amount))



# [코드 4-15]
  ## 가상의 데이터 활용 예제 스크립트로 실제 실행 불가
# data %>%
#   summarise( SUM_x = sum(x),
#              SUM_y = sum(y),
#              SUM_z = sum(z))



# [코드 4-16]
checkout %>%
  summarise(CNT_PER_CUST   = n() / n_distinct(cust_id),
            SALES_PER_CUST = sum(amount) / n_distinct(cust_id))



# [코드 4-17]
checkout %>%
  summarise(m   = min(amount),
            M   = max(amount),
            MED = median(amount), 
            Q1  = quantile(amount, 0.25), 
            Q3  = quantile(amount, 0.75)) 



# [코드 4-18]
checkout %>%
  filter(category == "전자상거래") %>%
  summarise(N              = n(),
            CNT_PER_CUST   = n() / n_distinct(cust_id),
            SALES_PER_CUST = sum(amount) / n_distinct(cust_id))



# [코드 4-19]
100 >= 99
100 < 99



# [코드 4-20]
customer %>%
  filter(age < 30) %>% 
  summarise(n_cust = n())

customer %>%
  filter(age >= 30) %>% 
  summarise(n_cust = n())



# [코드 4-21]
customer %>% 
  filter(gender == 1) %>% 
  summarise(n_cust = n())

customer %>% 
  filter(gender != 2) %>% 
  summarise(n_cust = n())




# [코드 4-22]
target_category = c("커피/음료전문점", "제과/아이스크림점")
target_category



# [코드 4-23]
checkout %>%
  filter(category %in% target_category) %>%
  summarise(MEAN = mean(amount))




# [코드 4-24]
list_func = c("sum", "mean", "max", "min")
grepl("n", list_func)



# [코드 4-25]
checkout %>%
  distinct(category)



# [코드 4-26]
checkout %>%
  filter(grepl("식", category)) %>%
  distinct(category)



# [코드 4-27]
checkout %>%
  filter(grepl("식", category)) %>% 
  summarise(MEAN = mean(amount))



# [코드 4-28]
checkout %>%
  filter(category %in% c("한식/일반음식점", "양식", "일식/생선회점", "중식", "기타음식점")) %>% 
  summarise(MEAN = mean(amount))



# [코드 4-29]
merchant %>% 
  filter(grepl("주유소$", name))



# [코드 4-30]
customer %>%
  filter(age >= 30) %>% 
  filter(age < 40) %>% 
  filter(gender == 1) %>%
  summarise(n = n())



# [코드 4-31]
customer %>%
  filter(between(age, 30, 39.9)) %>%
  filter(gender == 1 ) %>%
  summarise( n = n())



# [코드 4-32]
customer %>%
  filter(between(age, 30, 39.9) & gender == 1) %>%
  summarise(n = n())



# [코드 4-33]
customer %>%
  filter(between(age, 30, 39.9) | gender == 1) %>%
  summarise(n = n())



# [코드 4-34]
(3>2)
!(3>2)



# [코드 4-35]
customer %>%
  filter(!(between(age, 30, 39.9) & gender == 1)) %>%
  summarise(n = n())



# [코드 4-36]
customer %>%
  filter(!between(age, 30, 39.9) & gender == 1) %>%
  summarise(n = n())



# [코드 4-37]
checkout %>%
  filter(category == "편의점" | amount <= 3000 & cust_id == "C11476")



# [코드 4-38]
checkout %>%
  filter((category == "편의점" | amount <= 3000) & cust_id == "C11476")



# [코드 4-39]
customer %>%
  filter(between(age, 30, 39.9), gender == 1) %>%
  summarise(n = n())



# [코드 4-40]
customer %>%
  # filter(between(age, 30, 39.9), gender==1) %>%
  # filter(between(age, 30, 39.9), gender==2) %>%
  filter(between(age, 20, 29.9)) %>%
  summarise(n = n())



# [코드 4-41]
merchant %>% 
  distinct(category)

merchant %>% 
  filter(category == "편의점") %>% 
  summarise(가맹점수 = n())



# [코드 4-42]
merchant %>% 
  group_by(category) 



# [코드 4-43]
merchant %>% 
  group_by(category) %>% 
  summarise(가맹점수 = n())



# [코드 4-44]
merchant %>% 
  group_by(category) %>% 
  summarise(가맹점수 = n()) %>% 
  print(n = 50)



# [코드 4-45]
checkout %>% 
  group_by(cust_id) %>% 
  summarise(total = sum(amount))



# [코드 4-46]
checkout %>% 
  group_by(cust_id, category) %>% 
  summarise(n = n(),
            total = sum(amount))



# [코드 4-47]
checkout %>% 
  count(cust_id, category)



# [코드 4-48]
checkout %>% 
  group_by(cust_id) %>% 
  summarise(total = sum(amount)) %>% 
  arrange(total)



# [코드 4-49]
checkout %>% 
  group_by(cust_id) %>% 
  summarise(total = sum(amount)) %>% 
  arrange(desc(total)) 



# [코드 4-50]
checkout %>% 
  group_by(cust_id, category) %>% 
  summarise(n = n(), total = sum(amount)) %>% 
  arrange(cust_id, desc(total)) 



# [코드 4-51]
checkout %>% 
  filter(category %in% c("백화점", "대형마트", "슈퍼마켓")) %>% 
  group_by(cust_id, category) %>% 
  summarise(n = n(), total = sum(amount)) %>% 
  arrange(cust_id, desc(total)) 



# [코드 4-52]
checkout %>%
  filter(grepl("식", category)) %>%
  distinct( category )

checkout %>%
  distinct(category) %>% 
  filter(grepl("식", category)) 



# [코드 4-53]
system.time(
  checkout %>% 
    filter(category %in% c("백화점", "대형마트", "슈퍼마켓")) %>% 
    group_by(cust_id, category) %>% 
    summarise(n = n(), total = sum(amount)) %>% 
    arrange(cust_id, desc(total)) 
)


system.time(
  checkout %>% 
    group_by(cust_id, category) %>% 
    summarise(n = n(), total = sum(amount)) %>% 
    filter(category %in% c("백화점", "대형마트", "슈퍼마켓")) %>% 
    arrange(cust_id, desc(total)) 
)


system.time(
  checkout %>% 
    group_by(cust_id, category) %>% 
    summarise(n = n(), total = sum(amount)) %>% 
    arrange(cust_id, desc(total)) %>% 
    filter(category %in% c("백화점", "대형마트", "슈퍼마켓"))
)







# 4.5 ggplot2 패키지를 활용한 시각화 ------------------------------------------------


# [코드 4-54]
hist(checkout$amount)
boxplot(customer$age)



# [코드 4-55]
library(ggplot2)
ggplot(checkout, aes(x = amount))



# [코드 4-56]
ggplot(checkout, aes(x = amount)) + 
  geom_histogram() 



# [코드 4-57]
ggplot(checkout, aes(x = amount)) + 
  geom_histogram(binwidth = 50000) 



# [코드 4-58]
customer %>%
  summarise( m   = min(age),
             Q1  = quantile(age, 0.25),  
             MED = median(age),  
             Q3  = quantile(age, 0.75),
             M   = max(age)) 



# [코드 4-59]
ggplot(customer, aes(y = age)) +
  geom_boxplot() 



# [코드 4-60]
ggplot(checkout, aes(x = category, y = amount)) +
  geom_boxplot() 



# [코드 4-61]
ggplot(checkout, aes(x = category, y = amount)) +
  geom_boxplot() +
  theme(axis.text.x=element_text(angle = 90, hjust = 1))

  # macOS에서는 폰트 문제로 한글이 깨져서 네모로 보일 수 있음
  # 아래의 명령어를 실행해서 Apple Gothic 폰트 사용을 지정

  # macOS 사용자만 실행 
  theme_set(theme_gray() + theme(text=element_text(family='AppleGothic')))
  
  # 이후 다시 명령어를 실행하면 문제없이 한글 출력 가능
  # ggplot2의 테마(theme)에 대한 간단한 설명은 부록 A.5.7 참고
  



# [코드 4-62]
checkout %>% 
  ggplot(aes(category, amount)) +
  geom_boxplot() 



# [코드 4-63]
checkout %>% 
  filter(category %in% c("백화점", "대형마트", "슈퍼마켓")) %>% 
  ggplot(aes(category, amount)) +
  geom_boxplot() 



# [코드 4-64]
customer %>%
  group_by(gender) %>%
  summarise(n = n()) %>%
  ggplot(aes(gender, n)) +
  geom_col() 



# [코드 4-65]
customer %>%
  ggplot(aes(gender)) +
  geom_bar() 




# [코드 4-66]
agg = checkout %>%
  group_by(category) %>%
  summarise(MEAN = mean(amount)) 
agg


p = agg %>%
  ggplot(aes(category, MEAN)) +
  geom_col( ) 
p




# [코드 4-67]
p + 
  theme_minimal() +
  theme(axis.text.x = element_text(angle = 90, hjust = 1))


# macOS 사용자는 아래 명령어 실행
p + 
  theme_minimal() +
  theme(axis.text.x = element_text(angle = 90, hjust = 1, family='AppleGothic'))



# End of script