  # __________________________________________________________ #
  #                                |                           #
  #  이토록 쉬운                   |     "데이터는 답이다"     #
  #  데이터 요약과 시각화 with R   |       _                   #
  # ______________________________ |    __| |   __ _   _ __    #
  #                                |   / _` |  / _` | | '_ \   #
  #  임경덕                        |  | (_| | | (_| | | |_) |  # 
  #   - dataartproject@gmail.com   |   \__,_|  \__,_| | .__/   #
  #   - http://dataartproject.com  |                  |_|      #
  # _______________________________|__________________________ #



# 6장 | 분석 결과 공유하기

# 요약 데이터와 그래프의 저장





# 6.1 CSV 파일로 데이터 내보내기 ----------------------------------------------------


# [코드 6-1]
dir.create("result")



# [코드 6-2]
merc_region = merchant %>% 
  filter(grepl("분석로1길", address), 
         category %in% c("제과/아이스크림점", "커피/음료전문점", "편의점")) 

checkout_region = checkout %>% 
  filter(merc_id %in% merc_region$merc_id) 

c_region_cust = merge(checkout_region, customer, by = "cust_id")
agg_region_cust = c_region_cust %>%
  mutate( age_grp = cut(age,
                        breaks = seq(20, 90, 10),
                        labels = paste0(seq(20, 80, 10), "대"),
                        right = F, include.lowest = T),
          gender = case_when(
            gender == 1 ~ "1_남",
            gender == 2 ~ "2_여") ) %>% 
  group_by(merc_id, age_grp, gender) %>% 
  summarise(n = n(),
            n_cust = n_distinct(cust_id),
            total = sum(amount)) 

agg_region_cust



# [코드 6-3]
write.csv(agg_region_cust, file = "result/output.csv", row.names = F)          





# 6.2 이미지 파일로 그래프 내보내기 ----------------------------------------------------


# [코드 6-4]
ggsave("result/plot_1.png")



# [코드 6-5]
ggsave("result/plot_2.png", plot = p)


# [코드 6-6]
ggsave("result/plot_3.png", width = 100, height = 100, units= "mm")




# End of script