  # __________________________________________________________ #
  #                                |                           #
  #  이토록 쉬운                   |     "데이터는 답이다"     #
  #  데이터 요약과 시각화 with R   |       _                   #
  # ______________________________ |    __| |   __ _   _ __    #
  #                                |   / _` |  / _` | | '_ \   #
  #  임경덕                        |  | (_| | | (_| | | |_) |  # 
  #   - dataartproject@gmail.com   |   \__,_|  \__,_| | .__/   #
  #   - http://dataartproject.com  |                  |_|      #
  # _______________________________|__________________________ #



# Practice | 추가 자율 실습 


  # 책에는 없는 추가 실습 스크립트입니다.

  # 도전적이고 어려울 수 있습니다.
  # 주어진 실습 문제 말고 스스로 문제를 만들어서 직접 스크립트를 작성해보는 것을 추천합니다. 




# 추가 예제 데이터 다운로드/압축 풀기

  ## 아래의 명령어 두 줄을 순서대로 실행합니다.
  ## 구글 드라이브에서 추가 예제 데이터 파일을 다운받고, data 폴더에 압축을 풉니다. 

download.file('https://bit.ly/dap_T20', destfile = 'data/T20.zip', mode = 'wb')
unzip('data/T20.zip', exdir='data')


  # 출처 : 공공데이터포털 국민건강 정보(data.go.kr)
  # 설명 : 건강보험가입자 중 100만명의 1년간 병의원 진료 정보를 기록

  # 활용 : 실제 진료건수(관측치수)가 1000만건 이상으로 일반적인 분석 환경에서 메모리 문제 발생가능
  #        연도별 서울 지역의 외래 진료 약 200만건의 일부 변수만 선택
  # 기간 : 2018, 2019, 2020년 3개년(각각 T20_2018.csv, T20_2019.csv, T20_2020.csv으로 저장)

  # 참고 : 데이터 및 변수, 변수의 코드에 대한 자세한 설명은 T20_codebook.pdf 참고
  

  # 데이터에 포함된 변수 목록
      
    # IDV_ID          가입자일련번호
      ## 각 연도별로 선택된 가입자가 다르고 IDV_ID는 랜덤으로 지정됨
      ## 즉, 2020년의 IDV_ID가 1인 사람과 2019년의 IDV_ID가 1인 사람은 다른 사람
    # SEX             성별코드
    # AGE_GROUP       연령대코드
    # DSBJT_CD        진료과목코드 
    # MAIN_SICK       주상병코드 
      ## 주상병 코드 조회
      ## http://kssc.kostat.go.kr/ksscNew_web/link.do?gubun=004
    # EDEC_TRAMT      심결요양급여비용총액
    # EDEC_SBRDN_AMT  심결본인부담금
    # YEAR            연도






# 3장 관련 실습 ----------------------------------------------------------------

# [실습 1]
# data 폴더의 T20_2020.csv를 불러와서 T20_2020으로 저장하기




# [실습 2]
# [실습 1]과 동일한 방법으로 T20_2019.csv, T20_2018.csv를 불러와 각각 T20_2019, T20_2018로 저장하기




# [실습 3]
# 불러온 3개 데이터 각각의 관측치 개수 확인하기




# [실습 4]
# T20_2020의 변수 이름 확인하기




# [실습 5]
# head( )로 세 데이터의 첫 5개 관측치 확인하기




# [실습 6]
# rbind( )로 세 데이터를 하나로 통합하고 T20으로 저장하기
  ## 이후의 실습 예제는 모두 T20 데이터를 활용




# [실습 7]
# 아래의 명령어를 실행해서 기존 데이터를 삭제하고 메모리 확보하기








# 4장 관련 실습 ----------------------------------------------------------------

# [실습 8]
# 아래의 명령어를 실행해서 패키지 불러오기
library(dplyr)
library(ggplot2)




# [실습 9]
# summarise( )로 T20의 전체 진료건수와 EDEC_TRAMT의 합계 계산하기




# [실습 10]
# group_by(), n_distinct() 등을 활용하여 YEAR별로 진료건수, 진료가입자수, 가입자 당 진료건수 계산하기




# [실습 11]
# YEAR별로 MAIN_SICK이 'I10'인 관측치(본태성 고혈압)의 건수(진료건수)와 환자수(가입자수) 계산하기




# [실습 12]
# 2020년 한해 동안 AGE_GROUP별 가입자수와 EDEC_TRAMT의 합계를 계산하고, EDEC_TRAMT의 합계의 내림차순으로 정렬




# [실습 13]
# ggplot()으로 EDEC_SBRDN_AMT(본인부담금)의 히스토그램 그리기 




# [실습 14]
# EDEC_SBRDN_AMT이 100,000 이하인 관측치로 EDEC_SBRDN_AMT(본인부담금)의 히스토그램 그리기 



# [실습 15]
# MAIN_SICK별 진료건수(관측치수)를 계산하고, 10만 건 이상만 선택해서  막대그래프로 그리기








# 5장 관련 실습 ----------------------------------------------------------------

# [실습 16]
# DSBJT_CD별로 EDEC_TRAMT이 가장 큰 관측치 1개씩 확인하기




# [실습 17]
# AGE_GROUP별로 진료건수가 10000건 이상이면서 평균 EDEC_TRAMT가 가장 큰 DSBJT_CD 3개씩 선택하기




# [실습 18]
# 2020년 기준 MAIN_SICK별로 EDEC_TRAMT의 합, EDEC_SBRDN_AMT의 합을 계산하고
# EDEC_TRAMT 총액이 10억 이상이면서 본인부담금비율( (EDEC_SBRDN_AMT의 합)/(EDEC_TRAMT의 합) )이 가장 낮은 10개 MAIN_SICK 확인하기




# [실습 19]
# YEAR, SEX, AGE_GROUP별 진료건수 및 EDEC_TRAMT의 합계를 먼저 계산하고 
# mutate( )로 SEX의 1, 2 대신 '남', '여', AGE_GROUP의 1~17 대신 실제 연령대 값으로 바꾼 다음
# agg19로 저장하기

# (SEX는 직접 명령어를 작성하고 AGE_GROUP는 아래의 명령어를 활용 가능)

T20 %>% 
  mutate(AGE_GROUP = case_when(
           AGE_GROUP == 1  ~ "01_0_4세",
           AGE_GROUP == 2  ~ "02_5_9세",
           AGE_GROUP == 3  ~ "03_10_14세",
           AGE_GROUP == 4  ~ "04_15_19세",
           AGE_GROUP == 5  ~ "05_20_24세",
           AGE_GROUP == 6  ~ "06_25_29세",
           AGE_GROUP == 7  ~ "07_30_34세",
           AGE_GROUP == 8  ~ "08_35_39세",
           AGE_GROUP == 9  ~ "09_40_44세",
           AGE_GROUP == 10 ~ "10_45_49세",
           AGE_GROUP == 11 ~ "11_50_54세",
           AGE_GROUP == 12 ~ "12_55_59세",
           AGE_GROUP == 13 ~ "13_60_64세",
           AGE_GROUP == 14 ~ "14_65_69세",
           AGE_GROUP == 15 ~ "15_70_74세",
           AGE_GROUP == 16 ~ "16_75_79세",
           AGE_GROUP == 17 ~ "17_80_84세",
           AGE_GROUP == 18 ~ "18_85세_")) 





# [실습 20]
# [실습 19]의 agg19에서 2020년만 선택한 다음
# AGE_GROUP을 x축에 두고 SEX에 따라 색이 다른 (EDEC_TRAMT의 합계)의 막대그래프 그리기
# 단, geom_col(position='dodge')을 활용해서 나란한 막대그래프를 그리기




# [실습 21]
# 아래의 명령어로 만들어진 DSBJT_CD2를 활용하여
# AGE_GROUP, DSBJT_CD2별 EDEC_TRAMT의 합계를 계산하고 열지도로 표현하기

T20 %>% 
  mutate(DSBJT_CD2 = case_when(
    DSBJT_CD==1 ~ '01_내과',
    DSBJT_CD==2 ~ '02_신경과',
    DSBJT_CD==3 ~ '03_정신과',
    DSBJT_CD==4 ~ '04_외과',
    DSBJT_CD==5 ~ '05_정형외과',
    DSBJT_CD==9 ~ '09_마취통증의학과',
    DSBJT_CD==10 ~ '10_산부인과',
    DSBJT_CD==11 ~ '11_소아청소년과',
    DSBJT_CD==12 ~ '12_안과',
    DSBJT_CD==13 ~ '13_이비인후과',
    DSBJT_CD==14 ~ '14_피부과',
    DSBJT_CD==15 ~ '15_비뇨기과',
    DSBJT_CD==24 ~ '24_응급의학과',
    TRUE ~ '99_기타')) 




# [실습 22]
# [실습 21]에서 환자수(가입자수)를 추가로 계산하고, 열지도에 geom_text()로 함께 표현하기
  
  


# [실습 23]
# between()을 활용하여 AGE_GROUP이 13부터 18까지(60세 이상)인 관측치를 선택하고, 
# SEX, AGE_GROUP, MAIN_SICK별로 진료건수(관측치수)와 EDEC_TRAMT의 합계를 계산한 뒤
# SEX, AGE_GROUP별로 (EDEC_TRAMT의 합계) 기준 상위 3개 관측치를 선택하고 agg23으로 저장하기
# 주요 상병코드를 아래의 사이트에서 조회하기
# http://kssc.kostat.go.kr/ksscNew_web/link.do?gubun=004




# [실습 24]
# [실습 23]의 agg23에서 AGE_GROUP, MAIN_SICK를 각각 x, y축으로 하고
# (EDEC_TRAMT의 합계)에 따라 색이 다른 열지도를 그리기
# 단, facet_wrap()을 활용하여 SEX에 따라 나눠 그리기





















# 답안(예시) ------------------------------------------------------------------


# [실습 1]
# data 폴더의 T20_2020.csv를 불러와서 T20_2020으로 저장하기
T20_2020 = read.csv('data/T20_2020.csv')




# [실습 2]
# [실습 1]과 동일한 방법으로 T20_2019.csv, T20_2018.csv를 불러와 각각 T20_2019, T20_2018로 저장하기
T20_2019 = read.csv('data/T20_2019.csv')
T20_2018 = read.csv('data/T20_2018.csv')




# [실습 3]
# 불러온 3개 데이터 각각의 관측치 개수 확인하기
nrow(T20_2020)
nrow(T20_2019)
nrow(T20_2018)



# [실습 4]
# T20_2020의 변수 이름 확인하기
names(T20_2020)



# [실습 5]
# head( )로 세 데이터의 첫 5개 관측치 확인하기
head(T20_2020)
head(T20_2019)
head(T20_2018)



# [실습 6]
# rbind( )로 세 데이터를 하나로 통합하고 T20으로 저장하기
  ## 이후의 실습 예제는 모두 T20 데이터를 활용
T20 = rbind(T20_2018, T20_2019, T20_2020)




# [실습 7]
# 아래의 명령어를 실행해서 기존 데이터를 삭제하고 메모리 확보하기
rm(T20_2018, T20_2019, T20_2020)
gc()




# [실습 8]
# 아래의 명령어를 실행해서 패키지 불러오기
library(dplyr)
library(ggplot2)



# [실습 9]
# summarise( )로 T20의 전체 진료건수와 EDEC_TRAMT의 합계 계산하기
T20 %>% 
  summarise(n = n(),
            total = sum(EDEC_TRAMT))



# [실습 10]
# group_by(), n_distinct() 등을 활용하여 YEAR별로 진료건수, 진료가입자수, 가입자 당 진료건수 계산하기
T20 %>% 
  group_by(YEAR) %>% 
  summarise(n = n(),
            n_idv = n_distinct(IDV_ID),
            n_per_idv = n() / n_distinct(IDV_ID))



# [실습 11]
# YEAR별로 MAIN_SICK이 'I10'인 관측치(본태성 고혈압)의 건수(진료건수)와 환자수(가입자수) 계산하기
T20 %>% 
  filter(MAIN_SICK == 'I10') %>% 
  group_by(YEAR) %>% 
  summarise(n = n(),
            n_idv = n_distinct(IDV_ID))



# [실습 12]
# 2020년 한해 동안 AGE_GROUP별 가입자수와 EDEC_TRAMT의 합계를 계산하고, EDEC_TRAMT의 합계의 내림차순으로 정렬
T20 %>% 
  filter(YEAR == 2020) %>% 
  group_by(AGE_GROUP) %>% 
  summarise(n_idv = n_distinct(IDV_ID),
            total = sum(EDEC_TRAMT)) %>% 
  arrange(desc(total))



# [실습 13]
# ggplot()으로 EDEC_SBRDN_AMT(본인부담금)의 히스토그램 그리기 
T20 %>% 
  ggplot(aes(x=EDEC_SBRDN_AMT)) +
  geom_histogram()



# [실습 14]
# EDEC_SBRDN_AMT이 100,000 이하인 관측치로 EDEC_SBRDN_AMT(본인부담금)의 히스토그램 그리기 
T20 %>% 
  filter(EDEC_SBRDN_AMT <= 100000) %>% 
  ggplot(aes(x=EDEC_SBRDN_AMT)) +
  geom_histogram()



# [실습 15]
# MAIN_SICK별 진료건수(관측치수)를 계산하고, 10만 건 이상만 선택해서  막대그래프로 그리기
T20 %>% 
  group_by(MAIN_SICK) %>% 
  summarise(n = n()) %>% 
  filter(n >= 100000) %>% 
  ggplot(aes(x=MAIN_SICK, y=n)) + 
  geom_col()




# [실습 16]
# DSBJT_CD별로 EDEC_TRAMT이 가장 큰 관측치 1개씩 확인하기
T20 %>% 
  group_by(DSBJT_CD) %>% 
  slice_max(EDEC_TRAMT, n=1)




# [실습 17]
# AGE_GROUP별로 진료건수가 10000건 이상이면서 평균 EDEC_TRAMT가 가장 큰 DSBJT_CD 3개씩 선택하기
T20 %>% 
  group_by(AGE_GROUP, DSBJT_CD) %>% 
  summarise(n = n(),
            total = sum(EDEC_TRAMT)) %>% 
  filter(n>=10000) %>% 
  group_by(AGE_GROUP) %>% 
  slice_max(total, n=3)



# [실습 18]
# 2020년 기준 MAIN_SICK별로 EDEC_TRAMT의 합, EDEC_SBRDN_AMT의 합을 계산하고
# EDEC_TRAMT 총액이 10억 이상이면서 본인부담금비율( (EDEC_SBRDN_AMT의 합)/(EDEC_TRAMT의 합) )이 가장 낮은 10개 MAIN_SICK 확인하기
T20 %>% 
  filter(YEAR == 2020) %>% 
  group_by(MAIN_SICK) %>% 
  summarise( total = sum(EDEC_TRAMT),
             total_SBRDN = sum(EDEC_SBRDN_AMT)) %>% 
  filter(total >= 1000000000) %>% 
  slice_min(total_SBRDN/total, n=10)




# [실습 19]
# YEAR, SEX, AGE_GROUP별 진료건수 및 EDEC_TRAMT의 합계를 먼저 계산하고 
# mutate( )로 SEX의 1, 2 대신 '남', '여', AGE_GROUP의 1~17 대신 실제 연령대 값으로 바꾼 다음
# agg19로 저장하기
# (SEX는 직접 명령어를 작성하고 AGE_GROUP는 아래의 명령어를 활용)

agg19 = T20 %>% 
  group_by(YEAR, SEX, AGE_GROUP) %>% 
  summarise(n = n(),
            total = sum(EDEC_TRAMT)) %>% 

  mutate(SEX = case_when(SEX==1 ~ "남",
                         SEX==2 ~ "여"),
         AGE_GROUP = case_when(
           AGE_GROUP == 1  ~ "01_0_4세",
           AGE_GROUP == 2  ~ "02_5_9세",
           AGE_GROUP == 3  ~ "03_10_14세",
           AGE_GROUP == 4  ~ "04_15_19세",
           AGE_GROUP == 5  ~ "05_20_24세",
           AGE_GROUP == 6  ~ "06_25_29세",
           AGE_GROUP == 7  ~ "07_30_34세",
           AGE_GROUP == 8  ~ "08_35_39세",
           AGE_GROUP == 9  ~ "09_40_44세",
           AGE_GROUP == 10 ~ "10_45_49세",
           AGE_GROUP == 11 ~ "11_50_54세",
           AGE_GROUP == 12 ~ "12_55_59세",
           AGE_GROUP == 13 ~ "13_60_64세",
           AGE_GROUP == 14 ~ "14_65_69세",
           AGE_GROUP == 15 ~ "15_70_74세",
           AGE_GROUP == 16 ~ "16_75_79세",
           AGE_GROUP == 17 ~ "17_80_84세",
           AGE_GROUP == 18 ~ "18_85세_")) 

agg19



# [실습 20]
# [실습 19]의 agg19에서 2020년만 선택한 다음
# AGE_GROUP을 x축에 두고 SEX에 따라 색이 다른 (EDEC_TRAMT의 합계)의 막대그래프 그리기
# 단, geom_col(position='dodge')을 활용해서 나란한 막대그래프를 그리기

agg19 %>% 
  filter(YEAR == 2020) %>% 
  ggplot(aes(AGE_GROUP, y=total, fill=SEX))+
  geom_col(position='dodge')




# [실습 21]
# 아래의 명령어로 만들어진 DSBJT_CD2를 활용하여
# AGE_GROUP, DSBJT_CD2별 EDEC_TRAMT의 합계를 계산하고 열지도로 표현하기

T20 %>% 
  mutate(DSBJT_CD2 = case_when(
    DSBJT_CD==1 ~ '01_내과',
    DSBJT_CD==2 ~ '02_신경과',
    DSBJT_CD==3 ~ '03_정신과',
    DSBJT_CD==4 ~ '04_외과',
    DSBJT_CD==5 ~ '05_정형외과',
    DSBJT_CD==9 ~ '09_마취통증의학과',
    DSBJT_CD==10 ~ '10_산부인과',
    DSBJT_CD==11 ~ '11_소아청소년과',
    DSBJT_CD==12 ~ '12_안과',
    DSBJT_CD==13 ~ '13_이비인후과',
    DSBJT_CD==14 ~ '14_피부과',
    DSBJT_CD==15 ~ '15_비뇨기과',
    DSBJT_CD==24 ~ '24_응급의학과',
    TRUE ~ '99_기타')) %>% 
  group_by(AGE_GROUP, DSBJT_CD2) %>% 
  summarise(total = sum(EDEC_TRAMT)) %>% 
  ggplot(aes(AGE_GROUP, DSBJT_CD2, fill=total)) + 
  geom_tile() + 
  scale_fill_distiller(palette='Blues', direction=1)




# [실습 22]
# [실습 21]에서 환자수(가입자수)를 추가로 계산하고, 열지도에 geom_text()로 함께 표현하기
T20 %>% 
  mutate(DSBJT_CD2 = case_when(
    DSBJT_CD==1 ~ '01_내과',
    DSBJT_CD==2 ~ '02_신경과',
    DSBJT_CD==3 ~ '03_정신과',
    DSBJT_CD==4 ~ '04_외과',
    DSBJT_CD==5 ~ '05_정형외과',
    DSBJT_CD==9 ~ '09_마취통증의학과',
    DSBJT_CD==10 ~ '10_산부인과',
    DSBJT_CD==11 ~ '11_소아청소년과',
    DSBJT_CD==12 ~ '12_안과',
    DSBJT_CD==13 ~ '13_이비인후과',
    DSBJT_CD==14 ~ '14_피부과',
    DSBJT_CD==15 ~ '15_비뇨기과',
    DSBJT_CD==24 ~ '24_응급의학과',
    TRUE ~ '99_기타')) %>% 
  group_by(AGE_GROUP, DSBJT_CD2) %>% 
  summarise(total = sum(EDEC_TRAMT),
            n_IDV = n_distinct(IDV_ID)) %>% 
  ggplot(aes(AGE_GROUP, DSBJT_CD2, fill=total, label=n_IDV)) + 
  geom_tile() + 
  geom_text() + 
  scale_fill_distiller(palette='Blues', direction=1)

  
  
  


# [실습 23]
# between()을 활용하여 AGE_GROUP이 13부터 18까지(60세 이상)인 관측치를 선택하고, 
# SEX, AGE_GROUP, MAIN_SICK별로 진료건수(관측치수)와 EDEC_TRAMT의 합계를 계산한 뒤
# SEX, AGE_GROUP별로 (EDEC_TRAMT의 합계) 기준 상위 3개 관측치를 선택하고 agg23으로 저장하기
# 주요 상병코드를 아래의 사이트에서 조회하기
# http://kssc.kostat.go.kr/ksscNew_web/link.do?gubun=004
agg23 = T20 %>% 
  filter( between(AGE_GROUP, 13, 18) ) %>% 
  group_by(SEX, AGE_GROUP, MAIN_SICK) %>% 
  summarise(n = n(),
            total = sum(EDEC_TRAMT)) %>% 
  slice_max(total, n=3)
agg23



# [실습 24]
# [실습 23]의 agg23에서 AGE_GROUP, MAIN_SICK를 각각 x, y축으로 하고
# (EDEC_TRAMT의 합계)에 따라 색이 다른 열지도를 그리기
# 단, facet_wrap()을 활용하여 SEX에 따라 나눠 그리기
agg23 %>% 
  ggplot(aes(x=AGE_GROUP, y=MAIN_SICK, fill=total)) + 
  geom_tile() +
  scale_fill_distiller(palette='YlGnBu', direction=1) + 
  facet_wrap(vars(SEX))






# End of script